#include <math.h> 
#include <vector> 
#include <iostream>
#include <string.h>
#include <stdlib.h>
#include "Eta_Fun.h"


int main(int argc, char *argv[])
{
  
  char InputARF[1000];
  char  OutputRate[1000];
  double MassDMGeV;
  
  if (argc>1) {strcpy(InputARF, argv[1]); }
  if (argc>2) {strcpy(OutputRate, argv[2]); }
  if (argc>3) { MassDMGeV=atof(argv[3]); }
  
  FILE *txtfile = fopen(InputARF,"r");
  FILE *outfile = fopen(OutputRate,"w");

  if (txtfile == NULL)
    {  
      printf("Error! ResFun File could not open file\n");
      exit(-1); 
    }
  
  if (outfile  == NULL)
    {  
      printf("Error! Outout File could not open file\n");
      exit(-1); 
    }

  const double me = 0.510998928E-3;
  const double percm_GeV = 1.97326971780039025e-14;
  const double PI = 3.14159265358979;
  const double AXe = 131.293;
  const double avogadro_number = 6.02214129e+23; 
  const double N_atom_1kg_Xe = (1000.0*avogadro_number)/AXe;
  const  double electron_number = N_atom_1kg_Xe;   //kg^{-1}
     
  const double density = 0.4; //GeV cm^{-3}
  const double c1 = 1E-18;


  double NormFactor  = pow(c1,2)*1E-18*1E+3*86400*3E+10*(density*electron_number)/(MassDMGeV); //kg^{-1} keV^{-1} sec^{-1} 

  double En, Mom, Res;
 
  double MassDM = 1E+9*MassDMGeV ; //eV
  printf("%e \n", MassDM);
  
  double Rate, eta;
  
  std::vector<double> Energy;
  std::vector<double> Momentum;
  std::vector<double> EtaResFun;
 
  std::vector<double>FinalRate;
  std::vector<double>FinalEnergy;

  double tempValue = 0;
  double tempEnergy ;
  
  while(!feof(txtfile))
      {
	fscanf(txtfile, "%lf  %lf %lf \n", &En, &Mom, &Res);

	Energy.push_back(En);
	Momentum.push_back(Mom);
	
	eta = Eta_Fun(En, Mom, MassDM);
	Rate = (1.0/(2.0*PI))*(Res*Mom*eta)/2.5682E-9;
	EtaResFun.push_back(Rate);
      }

    for (int aa = 0; aa < Energy.size(); aa++)
      {
      
	if(Energy[aa+1] == Energy[aa])
	  {
	    tempValue = tempValue + (EtaResp[aa+1]+EtaResp[aa])*(Momentum[aa+1]-Momentum[aa])/2.0;
	    tempEnergy = Energy[aa];
	  }
	else
	  {
	    FinalRate.push_back(tempValue);
	    FinalEnergy.push_back(tempEnergy);
	    tempValue = 0;
	  }
     
      }

    for (int kk = 0; kk < FinalEnergy.size(); kk++)
      {
	fprintf(outfile, "%lf  %e \n", FinalEnergy[kk]*1E-3, NormFactor*FinalRate[kk]);
      }

    Energy.clear();
    Momentum.clear();
    EtaResFun.clear();
    FinalRate.clear();
    FinalEnergy.clear();

  
}




